# Copyright (C) 2018 Svetlana Tkachenko svetlana@members.fsf.org
#
#    This file is part of WeABit, Welcome-a-bit for Wikinews.
#
#    WeABit is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    WeABit is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with WeABit.  If not, see <https://www.gnu.org/licenses/>.

package wabget;


use strict;
use warnings;
use MediaWiki::API;
use Data::Dumper;
use XML::Feed;

use wabts;
use wabdeliver;

my $mw = MediaWiki::API->new();


sub _my_process_cat{
	my $self = shift;
    my $hr = shift; #hash ref
    
    my $wikiURL = $hr->{wikiURL};
    $mw->{config}->{api_url} = "$wikiURL/w/api.php";
    my $cat = $hr->{cat};
    my $articleType = $hr->{articleType};
    
    # Get the timestamp of the latest entry in the category
	my $cats = "$cat";
	if($articleType eq 'dev') {$cats = "$cat|Developing";}
	elsif($articleType eq 'pub') {$cats = "$cat|Published";}
    my $feedUrl = "$wikiURL/w/index.php?title=Special:NewsFeed&feed=rss&categories=$cats&namespace=0&count=60&hourcount=99924&ordermethod=categoryadd&stablepages=include";
    print "***Checking title***\r\n";
    my $feed = XML::Feed->parse(URI->new($feedUrl)) or die XML::Feed->errstr;
    print "Feed title: '", $feed->title, "'.\n";
    print "Feed URL: ", $feedUrl, " .\n";
    print "**** checking entries\r\n*";
    
    my $tsEpoch = 0;
    my @feedEntries = ();
    print "Entries: \r\n";
    print Dumper $feed->entries;
    print "\r\nDone showing entries.\r\n";
    exit;
    for my $entry ($feed->entries) {
		if($tsEpoch == 0){
		    $tsEpoch = wabts->parseTsFromAtomFeed($entry->{entry}->{pubDate});
		}
		push @feedEntries, { 
			'dt' => $entry->{entry}->{pubDate},
			'title' => $entry->{entry}->{title}
		};
		print "\r\n...entry date: ", $entry->{entry}->{pubDate}, " (epoch ", wabts->parseTsFromAtomFeed($entry->{entry}->{pubDate}), ")";
		print "\r\n...entry title: ", $entry->{entry}->{title};
		print "\r\n";
    }
    if ($tsEpoch > 0){
		# Compare the time stamps
		my $userTs = $hr->{userTs};
		print "... $cat - checking for time stamps! \r\n";
		if($userTs < $tsEpoch){ # A fresh message is available
			print "need to notify user! their time stamp is outdated!";
		    #log in to the wiki
		    $mw->login( {lgname => 'Gryllida', lgpassword => '***' } )
			    || die $mw->{error}->{code} . ': ' . $mw->{error}->{details};
			my $token = $mw->api({'action'=>'query','meta'=>'tokens'})->{query}->{tokens}->{csrftoken};
			my $result = $mw->api ( {
				'action' => 'edit',
				'title' => $hr->{talkPageTitle},
				'text' => $tsEpoch,
				'token' => $token
			}) || die $mw->{error}->{code} . ': ' . $mw->{error}->{details};
			print Dumper \@feedEntries;
			print "\r\n - printed.\r\n";
			$hr->{entries} = \@feedEntries;
			#print $hr->{entries};
			print "\r\n - printed v2.";
			wabdeliver->_notify_user($hr);
		}
}
}

1;

#_ _END_ _
